/*-
 * Copyright (C)2014..2014 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: mercumeter.h,v 1.2 2014/11/03 17:51:11 babolo Exp $
 */

#ifndef  _MEMETER_H_
# define _MEMETER_H_

__BEGIN_DECLS

#define MEMETER_HOST_ADDR 0xFFFF
#define MEMETER_BROADDR   0x3FFF

// CTR
#define MEMETER_SET_CONFIG      0x00
#define MEMETER_SET_TIMEDATE    0x01
#define MEMETER_SET_ADDR        0x06
#define MEMETER_SET_MB_REQ      0x12 /* ABSENT */
#define MEMETER_SET_P_LIST      0x14
#define MEMETER_SET_ROUTE       MEMETER_SET_P_LIST
#define MEMETER_SET_ADD_NODE    0x15
#define MEMETER_SET_DEL_NODE    0x16
#define MEMETER_SET_SL_CONFIG   0x18
#define MEMETER_SET_SEG_NUM     0x19
#define MEMETER_SET_SEG_STATUS  0x1A
#define MEMETER_SET_SEG_REQ     0x1B
#define MEMETER_SET_CLR_ALL_SEG 0x1D
#define MEMETER_SET_REPLACE_ID  0x1E
#define MEMETER_SET_PARENT      0x1F
#define MEMETER_SET_CLEAR_ST    0x7D
#define MEMETER_GET_CLEAR_ST    0x7D
#define MEMETER_GET_CONFIG      0x80
#define MEMETER_GET_TIMEDATE    0x81
#define MEMETER_GET_VERINFO     0x83
#define MEMETER_GET_ADDR        0x86
#define MEMETER_GET_NL_PAGE     0x90
#define MEMETER_GET_MB_STATUS   0x91 /* ABSENT */
#define MEMETER_GET_MB_REQ      0x92 /* ABSENT */
#define MEMETER_GET_MB_ANS      0x93 /* ABSENT */
#define MEMETER_GET_P_LIST      0x94
#define MEMETER_GET_ROUTE       MEMETER_GET_P_LIST
#define MEMETER_GET_MOD_CONFIG  0x97
#define MEMETER_GET_SL_CONFIG   0x98
#define MEMETER_GET_SEG_NUM     0x99
#define MEMETER_GET_SEG_STATUS  0x9A
#define MEMETER_GET_SEG_REQ     0x9B
#define MEMETER_GET_SEG_ANS     0x9C
#define MEMETER_GET_PARENT      0x9F
#define MEMETER_GET_TIMESLOT    0xA0
#define MEMETER_GET_LOG_FILE    0xF0

// PLC
#define MEMETER_PLCII_SCAN    0x00
#define MEMETER_PLCII_GETCNF  0x01
#define MEMETER_PLCII_SETIME  0x02
#define MEMETER_PLCII_CLOSE   0x03
#define MEMETER_PLCII_OPEN    0x04
#define MEMETER_PLCII_GETCNT  0x05
#define MEMETER_PLCII_THROUGH 0x40
#define MEMETER_PLCII_ILLEGAL 0xFE
#define MEMETER_PLCII_NOCOMM  0xFF

// MRC
#define MEMETER_CHANTST                0x00
#define MEMETER_PASS                   0x01
#define MEMETER_CLOSE                  0x02
#define MEMETER_SET_MEAN_PWR_INI     0x0003
#define MEMETER_SET_IND_TARIF        0x0103
#define MEMETER_SET_IND_PERIOD       0x0203
#define MEMETER_SET_TEST             0x0403
#define MEMETER_SET_CADDR            0x0503
#define MEMETER_SET_DATE_FIX         0x0803
#define MEMETER_SET_CONTROL_INI      0x0A03
#define MEMETER_SET_TIME             0x0C03
#define MEMETER_SET_TIME_CORR        0x0D03
#define MEMETER_SET_COMM_PARM        0x1503
#define MEMETER_SET_RESET            0x1603
#define MEMETER_SET_DST_DIS          0x1803
#define MEMETER_SET_DST_TIME         0x1903
#define MEMETER_SET_TRANS_COFF       0x1B03
#define MEMETER_SET_PASS             0x1F03
#define MEMETER_SET_ENERGY_RST       0x2003
#define MEMETER_SET_LOCATION         0x2203
#define MEMETER_SET_PEAK_TIME        0x2303
#define MEMETER_SET_MON_MAX_RST      0x2403
#define MEMETER_SET_CONST_AB         0x2703
#define MEMETER_SET_I_DIAP_DIS       0x2803
#define MEMETER_SET_N_CORR_DIS       0x2903
#define MEMETER_SET_TARIF_MODE       0x2A03
#define MEMETER_SET_PWR_LIMIT        0x2C03
#define MEMETER_SET_PWR_LIMIT_ENA    0x2D03
#define MEMETER_SET_ENERGY_LIMIT     0x2E03
#define MEMETER_SET_ENERGY_LIMIT_ENA 0x2F03
#define MEMETER_SET_IMP_OUT_MODE     0x3003
#define MEMETER_SET_LOAD_CTL_MODE    0x3103
#define MEMETER_SET_TIMEOUT_COFF     0x3203
#define MEMETER_SET_LOSS_ACC_MODE    0x3303
#define MEMETER_SET_LOSS             0x3403
#define MEMETER_SET_VALID_VALUES     0x3603
#define MEMETER_SET_MEAN_TIME        0x3703
#define MEMETER_GET_TIME             0x0004
#define MEMETER_J_ONOFF              0x0104
#define MEMETER_J_TIME_SET           0x0204
#define MEMETER_J_ONOFF1             0x0304
#define MEMETER_J_ONOFF2             0x0404
#define MEMETER_J_ONOFF3             0x0504
#define MEMETER_J_PWR_LIMIT          0x0604
#define MEMETER_J_TARIF_SET          0x0704
#define MEMETER_J_HOLIDAY_SET        0x0804
#define MEMETER_J_ENERGY_RST         0x0904
#define MEMETER_J_MEAN_PWR_INI       0x0A04
#define MEMETER_J_ENERGY_LIMIT1      0x0B04
#define MEMETER_J_ENERGY_LIMIT2      0x0C04
#define MEMETER_J_ENERGY_LIMIT3      0x0D04
#define MEMETER_J_ENERGY_LIMIT4      0x0E04
#define MEMETER_J_PWR_LIMIT_SET      0x0F04
#define MEMETER_J_ENERGY_LIMIT_SET   0x1004
#define MEMETER_J_LOSS_SET           0x1104
#define MEMETER_J_CASE               0x1204
#define MEMETER_J_REPROG             0x1304
#define MEMETER_J_STATUS             0x1404
#define MEMETER_J_PEAK_TIME_SET      0x1504
#define MEMETER_J_MAX_PWR_RST        0x1604
#define MEMETER_J_MIN_V1             0x2004
#define MEMETER_J_MIN_NOM_V1         0x2104
#define MEMETER_J_MAX_NOM_V1         0x2204
#define MEMETER_J_MAX_V1             0x2304
#define MEMETER_J_MIN_V2             0x2404
#define MEMETER_J_MIN_NOM_V2         0x2504
#define MEMETER_J_MAX_NOM_V2         0x2604
#define MEMETER_J_MAX_V2             0x2704
#define MEMETER_J_MIN_V3             0x2804
#define MEMETER_J_MIN_NOM_V3         0x2904
#define MEMETER_J_MAX_NOM_V3         0x2A04
#define MEMETER_J_MAX_V3             0x2B04
#define MEMETER_J_MIN_FREQ           0x2C04
#define MEMETER_J_MIN_NOM_FREQ       0x2D04
#define MEMETER_J_MAX_NOM_FREQ       0x2E04
#define MEMETER_J_MAX_FREQ           0x2F04
#define MEMETER_ENERGY_RST           0x0005
#define MEMETER_ENERGY_CUR_YEAR      0x0105
#define MEMETER_ENERGY_LAST_YEAR     0x0205
#define MEMETER_ENERGY_MON           0x0305
#define MEMETER_ENERGY_CUR_DAY       0x0405
#define MEMETER_ENERGY_LAST_DAY      0x0505
#define MEMETER_ENERGY_PHASE         0x0605
#define MEMETER_RMEM_1               0x0106
#define MEMETER_RMEM_2               0x0206
#define MEMETER_RMEM_3ALL            0x0306
#define MEMETER_RMEM_3APLUS          0x1306
#define MEMETER_RMEM_3AMINUS         0x2306
#define MEMETER_RMEM_3RPLUS          0x3306
#define MEMETER_RMEM_3RMINUS         0x4306
#define MEMETER_WMEM                   0x07
#define MEMETER_GET_SERIAL           0x0008
#define MEMETER_GET_TRANS_COFF       0x0208
#define MEMETER_GET_VERSION          0x0308
#define MEMETER_GET_CADDR            0x0508
#define MEMETER_GET_DST              0x0708
#define MEMETER_GET_FLAGS            0x0908
#define MEMETER_GET_STATUS           0x0A08
#define MEMETER_GET_LOCATION         0x0B08
#define MEMETER_GET_PEAK_TIME        0x0C08
#define MEMETER_GET_PEAK_PWR         0x0D08
#define MEMETER_GET_MAIN_1PWR      0x001108
#define MEMETER_GET_MAIN_1V        0x011108
#define MEMETER_GET_MAIN_1I        0x021108
#define MEMETER_GET_MAIN_1COFF     0x031108
#define MEMETER_GET_MAIN_1FREQ     0x041108
#define MEMETER_GET_MAIN_1ANGLE    0x051108
#define MEMETER_GET_VARIANT          0x1208
#define MEMETER_GET_MEAN_PWR_LAST    0x1308
#define MEMETER_GET_FIXED_PWR      0x001408
#define MEMETER_GET_FIXED_V        0x011408
#define MEMETER_GET_FIXED_I        0x021408
#define MEMETER_GET_FIXED_COFF     0x031408
#define MEMETER_GET_FIXED_FREQ     0x041408
#define MEMETER_GET_FIXED_ANGLE    0x051408
#define MEMETER_GET_FIXED_DATE     0x0E1408
#define MEMETER_GET_FIXED_ENERGY   0x0F1408
#define MEMETER_GET_MAIN_PWR       0x001608
#define MEMETER_GET_MAIN_V         0x011608
#define MEMETER_GET_MAIN_I         0x021608
#define MEMETER_GET_MAIN_COFF      0x031608
#define MEMETER_GET_MAIN_FREQ      0x041608
#define MEMETER_GET_MAIN_ANGLE     0x051608
#define MEMETER_GET_TARIF_STATUS     0x1708
#define MEMETER_GET_LOAD_CTL_STATUS  0x1808
#define MEMETER_GET_PWR_LIMIT        0x1908
#define MEMETER_GET_ENERGY_LIMIT     0x1A08
#define MEMETER_GET_IND_TARIF        0x1B08
#define MEMETER_GET_IND_PERIOD       0x1C08
#define MEMETER_GET_TIMEOUT_COFF     0x1D08
#define MEMETER_GET_LOSS_ACC_MODE    0x1E08
#define MEMETER_GET_LOSS             0x1F08
#define MEMETER_GET_VALID_VALUES     0x2008
#define MEMETER_GET_MEAN_TIME        0x2108

typedef struct {
    BLIN_flag flags;
#   define    MEMETER_IS_CNT 0x000100
#   define    MEMETER_IS_CTR 0x000001
#   define    MEMETER_IS_NUM 0x000002
#   define    MEMETER_IS_LIN 0x000003
    u_int32_t addr1;
    u_int16_t addr2;
    u_int8_t  type;
#   define    MEMETER_L_SIO 0
#   define    MEMETER_L_CTR 1
#   define    MEMETER_L_PLC 2
#   define    MEMETER_L_MRC 3
    u_int8_t  len;
    u_char    msg[];
} memeter_msg;

__END_DECLS

#endif /* _MEMETER_H_ */
